ReadyLabelName = class(Turbine.UI.Control)
function ReadyLabelName:Constructor(player, parent, index)
    Turbine.UI.Control.Constructor(self)
    self:SetParent(parent)
    self:SetVisible(true)
    self:SetSize(120, 20)
    self:SetPosition(120 * ((index - 1) % 4), 25 + 20 * math.floor((index - 1) / 4))
    --self:SetBackColor(Turbine.UI.Color( math.random(), math.random(), math.random() ) )
    self:SetMouseVisible(false)
    --self:SetWantsUpdates(true)

    self.icon = Turbine.UI.Label()
    self.icon:SetParent(self)
    self.icon:SetSize(20, 20)
    self.icon:SetPosition(0, 0)
    self.icon:SetBlendMode( Turbine.UI.BlendMode.AlphaBlend )
    self.icon:SetBackColorBlendMode( Turbine.UI.BlendMode.Multiply )
    self.icon:SetBackground(ClassIconTable[player:GetClass()])
    self.icon:SetMouseVisible(false)

    self.label = Turbine.UI.Label()
    self.label:SetParent(self)
    self.label:SetSize(100, 20)
    self.label:SetPosition(20, 0)
    self.label:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft)
    self.label:SetFont(Turbine.UI.Lotro.Font.BookAntiquaBold18)
    self.label:SetFontStyle(Turbine.UI.FontStyle.Outline)
    self.label:SetMouseVisible(false)
    self.label:SetVisible(true)
    self.label:SetMultiline(false)
    self.label:SetOutlineColor(Turbine.UI.Color(0,0,0))
    --self.label:SetBackColor(Turbine.UI.Color(0, 0, 0))
    self.label:SetText(NameHandlerObject:GetName(player:GetName(), true, "ReadyLabel", ""))
    --self.label:SetText(index)
    self.label:SetForeColor(Turbine.UI.Color(1, 1, 1))

end

function ReadyLabelName:UpdateReadyState(state)
    if state then
        self.label:SetForeColor(Turbine.UI.Color(0, 1, 0))
    else
        self.label:SetForeColor(Turbine.UI.Color(1, 0, 0))
    end
end

function ReadyLabelName:SetDefault()
    self.label:SetForeColor(Turbine.UI.Color(1, 1, 1))
end
